// Sprocket Framework header file
// SerialNumberProtection.h


#ifndef		_SERIALNUMBERPROTECTION_
#define		_SERIALNUMBERPROTECTION_

#ifndef __APPLETALK__
#include <Appletalk.h>
#endif

class	TSerialNumberProtection
{
public:
						TSerialNumberProtection(short	ResourceID);
	virtual				~TSerialNumberProtection();


	OSErr				EnableProtection(void);
	
	OSErr				RegisterName( UInt8 inSocket );
	
	virtual OSErr		ReadRegistration(StringPtr SN, StringPtr Name, StringPtr Company);
	virtual OSErr		WriteRegistration(StringPtr SN, StringPtr Name, StringPtr Company);
	virtual OSErr		VerifyRegistration(StringPtr SN, StringPtr Name, StringPtr Company);
	
	
	enum {
						kNoLicense = 0,
						kSingleUserLicense = 1,
						kFiveUserLicense = 5,
						kSiteLicense = 32766
			};


protected:

	void				MangleRegistration(void);
	void				UnmangleRegistration(void);

	NamesTableEntry		fNTE;
	EntityName			fEntity;
	Str32				fSerialNumber;
	Str255				fName;
	Str255				fCompany;
	Str255				fPlainName;
	short				fNumOfLicenses;
	short				fResourceID;
};
	
#endif