// Sprocket Framework header file
// DialogWindow.h



#ifndef		_DIALOGWINDOW_
#define		_DIALOGWINDOW_

#ifndef		_WINDOW_
#include	"Window.h"
#endif

#ifndef		__DIALOGS__
#include	<Dialogs.h>
#endif

typedef	short	DialogTemplateID;
typedef	short	DialogItemID;


class	TDialogWindow	:	public	TWindow
{
protected:

	DialogTemplateID	fTemplateID;
	
	//	Protect the constructor, because this is an abstract class

						TDialogWindow(DialogTemplateID theDialogTemplate);

public:

	virtual	Boolean		EventFilter(EventRecord *theEvent);
	virtual	Boolean		FilterDialogEvent(EventRecord *theEvent, short *itemHit );

	virtual WindowRef	MakeNewWindow(WindowRef behindWindow);
	virtual	Boolean		Close(void);

	virtual void		Activate(Boolean activating);
	virtual void		Draw(void);
	virtual void		Click(EventRecord *anEvent);

	virtual	void		AdjustMenusBeforeMenuSelection(void);
	virtual Boolean		DoCommand(CommandID command);
	
//	New methods that MUST be overridden:

	virtual	void		ItemHit(short theItem) = 0;
	
	inline DialogRef	GetDialogRef(void)	{ return (DialogRef) fWindow; }
	};

#endif
